Attribute VB_Name = "modProcess"
'RUMINT, A PVR for network traffic
'Copyright (C) 2005 Greg Conti

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Option Explicit

'switch to struct
'Private Type FOOBAR
'  foo As Long
'  bar As Long
'End Type


Dim IPprotocol As Long

Dim UDPsourceport As Long 'in theory this should be an unsigned int (16 bits)
Dim UDPdestinationport As Long 'in theory this should be an unsigned int (16 bits)
Dim TCPsourceport As Long 'in theory this should be an unsigned int (16 bits)
Dim TCPdestinationport As Long 'in theory this should be an unsigned int (16 bits)
Dim TCPURG As Boolean 'urgent flag
Dim TCPACK As Boolean 'acknowledgement flag
Dim TCPPSH As Boolean 'push flag
Dim TCPRST As Boolean 'reset connection flag
Dim TCPSYN As Boolean 'synchronize flag
Dim TCPFIN As Boolean 'end of data flag


'This subroutine calculates the byte frequency relative to each packet
'Results are stored in a global array called modLibrary.packetByteFrequency
'I'm using a single datatype to hold the frequencies, this might
'need to change when looking at larger objects such as those found in IPv6
'or jumbo ethernet frames in order to gain increased precision

Public Sub byteFrequency(ByVal packetTxt As Variant, ByVal packetLen As Long)
    Dim loopCounter As Long
    'Dim differentBytes as Long
    
    'differentBytes = 0
               
    'clear the frequency counter
    For loopCounter = 0 To modLibrary.MAXSYMBOLSINENCODING
      modLibrary.packetByteFrequency(loopCounter) = 0
    Next loopCounter
       
    'count the number of occurances of each byte and temporarily store in frequency array
      For loopCounter = 0 To packetLen - 1
        modLibrary.packetByteFrequency(packetTxt(loopCounter)) = modLibrary.packetByteFrequency(packetTxt(loopCounter)) + 1#
      Next loopCounter
    
    'For loopCounter = 0 To modLibrary.MAXSYMBOLSINENCODING
      'If modLibrary.packetByteFrequency(loopCounter) > 0 Then differentBytes = differentBytes + 1
    'Next loopCounter
    
    'calculate the frequency of each byte and store in frequency array
      If (packetLen - 1) > 0 Then 'check for division by zero, on the off chance of a zero len packet
        For loopCounter = 0 To modLibrary.MAXSYMBOLSINENCODING
          modLibrary.packetByteFrequency(loopCounter) = modLibrary.packetByteFrequency(loopCounter) / (packetLen - 1)
        Next loopCounter
        
        'calculate the average frequency for the packet
         modLibrary.packetAverageByteFrequency = 1 / (packetLen - 1)
         'Debug.Print modLibrary.packetAverageByteFrequency
      End If
End Sub

'this can probably be deleted
'for non IP packets this subroutine sets flags for all IP values
Private Sub clearIP(packetlocation As Long)
  Call modLibrary.setIPVersion(packetlocation, -1)
  Call modLibrary.setIPHeaderLen(packetlocation, -1)
  Call modLibrary.setDifferentiatedServices(packetlocation, -1)
  Call modLibrary.setIPtotalLength(packetlocation, -1, -1)
  Call modLibrary.setIPidentification(packetlocation, -1, -1)
  Call modLibrary.setIPFlags(packetlocation, -1)
  Call modLibrary.setIPfragmentOffset(packetlocation, -1, -1)
  Call modLibrary.setIPTTL(packetlocation, -1)
  Call modLibrary.setPacketIPtransportProtocol(packetlocation, -1)
  Call modLibrary.setIPheaderchecksum(packetlocation, -1, -1)
  Call modLibrary.setSourceIP(packetlocation, -1, -1, -1, -1)
  Call modLibrary.setDestIP(packetlocation, -1, -1, -1, -1)
  
  'UDP
  Call modLibrary.setUDPsourcePort(packetlocation, -1, -1)
  Call modLibrary.setUDPdestPort(packetlocation, -1, -1)
  
  'TCP
  Call modLibrary.setTCPsourcePort(packetlocation, -1, -1)
  Call modLibrary.setTCPdestPort(packetlocation, -1, -1)
  
    'TCPsourceport = ((packetTxt(34) * 256) + packetTxt(35))
    'TCPdestinationport = ((packetTxt(36) * 256) + packetTxt(37))
    'Debug.Print TCPsourceport & " T " & TCPdestinationport
    
  'this should probably be deleted
    TCPURG = -1
    TCPACK = -1
    TCPPSH = -1
    TCPRST = -1
    TCPSYN = -1
    TCPFIN = -1
    
End Sub

Private Sub dissectIP(packetlocation As Long, ByVal packetTxt As Variant, ByVal packetLen As Long)
  Dim IPversion As Long
  Dim IPheaderLen As Long
  Dim Offset As Long 'used to hold offset when IP options exist
  
    '********* Network Layer (layer 3) position 14+ *********
  Call modLibrary.setIPVersion(packetlocation, packetTxt(14)) 'subroutine will extract ip version, the first four bits of position 14
  Call modLibrary.setIPHeaderLen(packetlocation, packetTxt(14)) '(n*32bits) subroutine will extract ip header length, last four bits of 14
  Call modLibrary.setDifferentiatedServices(packetlocation, packetTxt(15))
  Call modLibrary.setIPtotalLength(packetlocation, packetTxt(16), packetTxt(17))
  Call modLibrary.setIPidentification(packetlocation, packetTxt(18), packetTxt(19))
  Call modLibrary.setIPFlags(packetlocation, packetTxt(20)) 'first three bits!!!
  Call modLibrary.setIPfragmentOffset(packetlocation, packetTxt(20), packetTxt(21)) 'first four bits of 20!!!
  Call modLibrary.setIPTTL(packetlocation, packetTxt(22))
  Call modLibrary.setPacketIPtransportProtocol(packetlocation, packetTxt(23))
  Call modLibrary.setIPheaderchecksum(packetlocation, packetTxt(24), packetTxt(25))
  Call modLibrary.setSourceIP(packetlocation, packetTxt(26), packetTxt(27), packetTxt(28), packetTxt(29))
  Call modLibrary.setDestIP(packetlocation, packetTxt(30), packetTxt(31), packetTxt(32), packetTxt(33))
  
  'ipoptions (used only if IP headerlen > 5 (32bit) blocks)
      
  ' fill variables needed for later decision making
  IPversion = modLibrary.getIPVersion(packetlocation)
  IPprotocol = modLibrary.getPacketIPtransportProtocol(packetlocation)
  IPheaderLen = modLibrary.getIPHeaderLen(packetlocation)
  If IPheaderLen >= 5 Then Offset = (IPheaderLen - 5) * 4 Else Offset = 0 'need to check for too big
  If IPheaderLen <> 5 Then Debug.Print "warning: ipheaderlen <" & IPheaderLen & "> 5   " & IPheaderLen
  
  '********* Transport Layer (layer 4) *********
  
  'see http://www.iana.org/assignments/protocol-numbers
  
  'in most cases transport layer protocol will start at 34
  'if ipprotocol -...
  '  1 ICMP
  '  2 IGMP
  '  6 TCP
  ' 17 UDP
  
  If (IPprotocol = 1) Then 'ICMP
    'fill ICMP data
  Else
    'fill values with -1
  End If
  
  If (IPprotocol = 17) Then 'UDP
    Call modLibrary.setUDPsourcePort(packetlocation, packetTxt(34 + Offset), packetTxt(35 + Offset))
    Call modLibrary.setUDPdestPort(packetlocation, packetTxt(36 + Offset), packetTxt(37 + Offset))
  Else
    'fill values with -1?
  End If
  
  If (IPprotocol = 6) Then 'TCP
    Call modLibrary.setTCPsourcePort(packetlocation, packetTxt(34 + Offset), packetTxt(35 + Offset))
    Call modLibrary.setTCPdestPort(packetlocation, packetTxt(36 + Offset), packetTxt(37 + Offset))
    Call modLibrary.setTCPsequencenumber(packetlocation, packetTxt(38 + Offset), _
                                         packetTxt(39 + Offset), packetTxt(40 + Offset), packetTxt(41 + Offset))
  
    'TCPsourceport = ((packetTxt(34) * 256) + packetTxt(35))
    'TCPdestinationport = ((packetTxt(36) * 256) + packetTxt(37))
    'Debug.Print TCPsourceport & " T " & TCPdestinationport
    
    TCPURG = packetTxt(47) And 32 'extract urgent bit
    TCPACK = packetTxt(47) And 16 'extract acknowledgement bit
    TCPPSH = packetTxt(47) And 8 'extract push bit
    TCPRST = packetTxt(47) And 4 'extract reset bit
    TCPSYN = packetTxt(47) And 2 'extract synchronization bit
    TCPFIN = packetTxt(47) And 1 'extract fin bit
    
    'Debug.Print TCPURG & " " & TCPACK & " " & TCPPSH & " " & TCPRST & " " & TCPSYN & " " & TCPFIN
    
  End If
End Sub



'need to include code for ethernet variant and non-IP packets
'something like a "valid packet field"
Public Sub dissect(packetlocation As Long, ByVal packetTxt As Variant, ByVal packetLen As Long)

  Dim EtherType As Long
      
  '********* Link Layer (layer 2) position 0 - 13 (unverified)*********
  
  'modLibrary.setEtherDestination(packetLocation, packetTxt(0), packetTxt(1), _
                                                , packetTxt(2), packetTxt(3), _
                                                , packetTxt(4), packetTxt(5))
  
  'modLibrary.setEtherSource(packetLocation, packetTxt(6), packetTxt(7), _
                                           , packetTxt(8), packetTxt(9), _
                                           , packetTxt(10), packetTxt(11))
  
  Call modLibrary.setEtherType(packetlocation, packetTxt(12), packetTxt(13))
  EtherType = modLibrary.getEtherType(packetlocation)
  If EtherType = 2048 Then   ' 2048 = 0x800
    Call dissectIP(packetlocation, packetTxt, packetLen)
  Else
    'clearIP (packetlocation)
  End If
  'see for more common ethertypes http://www.networksorcery.com/enp/protocol/802/ethertypes.htm
  
End Sub

'Public Function getIPProtocol() as long
'  getIPProtocol = IPprotocol
'End Function
    
'Public Function getTCPURG() As Boolean
'  getTCPURG = TCPURG
'End Function
    
'Public Function getTCPACK() As Boolean
'  getTCPACK = TCPACK
'End Function

'Public Function getTCPPSH() As Boolean
'  getTCPPSH = TCPPSH
'End Function

'Public Function getTCPRST() As Boolean
'  getTCPRST = TCPRST
'End Function

'Public Function getTCPSYN() As Boolean
'  getTCPSYN = TCPSYN
'End Function

'Public Function getTCPFIN() As Boolean
'  getTCPFIN = TCPFIN
'End Function

'Public Function getUDPsourceport() As Long
'  getUDPsourceport = UDPsourceport
'End Function

'Public Function getUDPdestinationport() As Long
'  getUDPdestinationport = UDPdestinationport
'End Function

