Attribute VB_Name = "modVisualize"
'RUMINT, A PVR for network traffic
'Copyright (C) 2005 Greg Conti

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Option Explicit

'Declare Glogal Constants
Public Const MAXVIS = 6  'number of vis windows 1 to N
Public gPlotColor As ColorConstants 'initialized in modInit

Public Declare Function BitBlt Lib "gdi32" _
                (ByVal hDestDC As Long, _
                 ByVal X As Long, _
                 ByVal Y As Long, _
                 ByVal nWidth As Long, _
                 ByVal nHeight As Long, _
                 ByVal hSrcDC As Long, _
                 ByVal xSrc As Long, _
                 ByVal ySrc As Long, _
                 ByVal dwRop As Long) As Long

Public Sub initVisAll()
  frmVis4.initVisAll
  frmVis2.initVis2All
End Sub

'Plot a portion of the buffer
Public Sub selectedPlot(ByVal startPacket As Long, ByVal endPacket As Long)
  Dim counter As Long
  Dim byteCounter As Long
  Dim currentbyte As Long
  Dim packedBytePacket(0 To 1600) As Long 'holds packed byte data, needed for packetx compatibility, assumes ether RFC's 1518 byte frame limit
  For counter = startPacket To endPacket
    'If (counter <= modLibrary.packetBufferIndex) Then
      If frmFilters.filter(counter) = True Then
        For byteCounter = 0 To modLibrary.getPacketLen(counter) - 1
          currentbyte = modLibrary.getPacketByte(counter, byteCounter)
          packedBytePacket(byteCounter) = currentbyte
          DoEvents
        Next byteCounter
        DoEvents
        Call modVisualize.Plot(counter, packedBytePacket, modLibrary.getPacketLen(counter) + 1)
      End If
    'Else
    '  Exit For 'you have hit the end of the buffer, then exit loop
    'End If
      
  Next counter
End Sub

'todo: live capture truncates final byte
Private Sub Plot(ByVal packetNumber As Long, ByVal packetTxt As Variant, ByVal packetLen As Long)
  Dim IPprotocol As Long
  Dim protocolFilter As Boolean

  DoEvents 'let Windows process events outside loop
  
    ' perform filtering
  If (Not modFilters.filter(packetNumber)) Then 'if passes filter check then plot
      
    Call modProcess.byteFrequency(packetTxt, packetLen)
    
    
    If frmVis1.Visible = True Then 'text rainfall
      Call frmVis1.Plot(packetNumber, packetTxt, packetLen)
      Call frmVis1.plotThumbnail(packetLen)
    Else
      Call frmVis1.plotThumbnail(packetLen)
    End If
    
    If frmVis2.Visible = True Then 'byte frequency
      Call frmVis2.Plot(packetNumber, modLibrary.packetByteFrequency())
      Call frmVis2.plotThumbnail(modLibrary.packetByteFrequency())
    Else
      Call frmVis2.plotThumbnail(modLibrary.packetByteFrequency())
    End If
    
    If frmVis3.Visible = True Then 'parallel coordinate plot
      Call frmVis3.Plot(packetNumber)
      Call frmVis3.plotThumbnail(packetNumber)
    Else
      Call frmVis3.plotThumbnail(packetNumber)
    End If
    
    If frmVis4.Visible = True Then 'packet length
      Call frmVis4.Plot(packetNumber, packetTxt, packetLen)
      Call frmVis4.plotThumbnail(packetTxt, packetLen)
    Else
      Call frmVis4.plotThumbnail(packetTxt, packetLen)
    End If
    
     If frmVis5.Visible = True Then 'scatter plot
      Call frmVis5.Plot(packetNumber)
      Call frmVis5.plotThumbnail(packetNumber)
    Else
      Call frmVis5.plotThumbnail(packetNumber)
    End If
    
      If frmVis6.Visible = True Then 'combined vis
      Call frmVis6.Plot(packetNumber)
      Call frmVis6.plotThumbnail(packetNumber)
    Else
      Call frmVis6.plotThumbnail(packetNumber)
    End If
    
    If frmVis7.Visible = True Then 'detail view
      Call frmVis7.Plot(packetNumber, packetTxt, packetLen)
      'Call frmVis7.plotThumbnail(packetNumber)
    Else
      'Call frmVis7.plotThumbnail(packetNumber)
    End If
    
    
  End If
  
End Sub

Public Sub ScreenshotAll()
  Dim systemTime As String
  systemTime = Format(Now, "yyyymmdd_hhnnss")
  
  If frmVis1.Visible = True Then Call frmVis1.ScreenShot(systemTime)
  If frmVis2.Visible = True Then Call frmVis2.ScreenShot(systemTime)
  If frmVis3.Visible = True Then Call frmVis3.ScreenShot(systemTime)
  If frmVis4.Visible = True Then Call frmVis4.ScreenShot(systemTime)
  If frmVis5.Visible = True Then Call frmVis5.ScreenShot(systemTime)
  If frmVis6.Visible = True Then Call frmVis6.ScreenShot(systemTime)
  
End Sub

Public Sub clearAllVisualizationWindows()
  frmVis1.clear
  frmVis2.clear
  frmVis3.clear
  frmVis4.clear
  frmVis5.clear
  frmVis6.clear
  frmVis7.clear
End Sub

